︠4e97e99d-aec9-42ba-9b8f-b25a84002e39︠
# TODO: figure out a way to determine if f is an expression or callable symbolic function for the if statement.

def make_coordinate_plot3d(transformation, function_variable,parameter_variables):
    def new_plot(f, var1_range, var2_range,**kwds):
        f_is_expression=True
        
        if f_is_expression:
            # if f is an expression, then we can use .subs.  This is faster, because parametric_plot3d
            # can then use fast_float
            if len(var1_range)==3:
                vars=[var1_range[0], var2_range[0]]
            else:
                vars=sage.symbolic.ring.var('v1,v2')
            plot_func=[t.subs({function_variable:f, parameter_variables[0]:vars[0], parameter_variables[1]:vars[1]}) 
                        for t in transformation]
        else:
            # if f is not a symbolic expression or function, use the following
            # We could make this faster by using fast_float on the components of transformation
            # We need to do the function and map instead of just a list comprehension because
            # of python scoping; see http://lackingrhoticity.blogspot.com/2009/04/python-variable-binding-semantics-part.html
            def subs_func(t):
                return lambda x,y: t.subs({function_variable:f(x,y), parameter_variables[0]:x, parameter_variables[1]:y})
            plot_func=map(subs_func,transformation)

        return parametric_plot3d(plot_func, var1_range, var2_range,**kwds)
    return new_plot
︡1b1c52e0-1d6c-4685-9215-5729bbde39fb︡︡
︠a37f81a4-5a7f-4847-921a-67184c6c6d11︠
var('r,t,p')
︡1654e7ca-7198-4823-a4e1-fa328bd8e336︡{"stdout": "(r, t, p)"}︡
︠575c63cf-8ba4-4a15-9f73-81f6884b8940︠
jason_spherical_plot3d=make_coordinate_plot3d([r*cos(t)*sin(p), r*sin(t)*sin(p), r*cos(p)], function_variable=r, parameter_variables=[t,p])
︡d767a23b-743d-4d58-a454-ec9562df3e56︡︡
︠a75a37a3-d6a1-40fb-a7db-5670cb9f92ea︠
jason_spherical_plot3d(2,(t,0,pi/4),(p,0,pi))
︡0de2ffee-9a34-4623-afc5-ee762c28f218︡︡
︠42bdf76d-f151-4dee-b66f-e64d7db1a4f4︠
oscar_spherical_plot3d=make_coordinate_plot3d([r*cos(p)*sin(t), r*sin(p)*sin(t), r*cos(t)], function_variable=r, parameter_variables=[t,p])
︡f6b4f326-6e74-42a9-afef-69fb360406ca︡︡
︠bf4e5e79-fc7e-46f3-b7f9-0f47d94de90c︠
var('x,y')
︡5b6dbc4c-4096-49e9-82e1-689f4d602905︡{"stdout": "(x, y)"}︡
︠c435a4d5-79d1-452d-a610-0f2f2abd827b︠
oscar_spherical_plot3d(2,(x,0,pi/4),(y,0,pi))
︡c75c751d-24f7-469e-b9c1-d89c745bef91︡︡
︠9f2068e6-7f63-4dc4-80f0-a0fd2cbdb515︠
var('x,y,z,t')
︡ed92dabd-f1a0-4873-8e47-bad982c3fb0f︡{"stdout": "(x, y, z, t)"}︡
︠22b6db86-83af-4bd3-abee-d0681126c689︠
cylindrical_plot3d=make_coordinate_plot3d([r*cos(t)*z, r*sin(t)*z, z], function_variable=z, parameter_variables=[r,t])
︡15ef6454-8f55-44b6-b5e4-d9c017f7ae51︡︡
︠d4ebc385-be89-447f-a452-7be4caad1412︠
cylindrical_plot3d(t,(r,0,3),(t,0,3*pi))
︡e42cbaf4-922e-4d34-bebb-7eedf32df12d︡︡
